/*
 *  Author     : Arne Vajhj
 *
 *  Programmed : february 1996
 *
 *  Purpose    : Query module DECnet interface to QI-server
 *
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ph.h"
#include "net.h"

#ifdef PW
void pc2isolatin();
void isolatin2pc();
#endif

int phquery(char *cmd,char *res,int reslen)
{
   int n,ix;
   if(net_create(getenv(QISERVER),QITASK)) {
      net_write(cmd);
      ix = 0;
      while(!net_eof()) {
         n = net_read(res+ix,reslen-ix);
         if(res[ix]=='\xFF') break;
         ix = ix+n;
         res[ix] = '\n';
         ix++;
      }
      res[ix] = '\0';
      net_close();
      return TRUE;
   } else {
      return FALSE;
   }
}

int query_one_in_all(char *q,void action())
{
   int i,nfld,newval,oldval;
   char *s,*s2,*s3;
   char tmp[80];
   char res[20000];
   char flds[100][32];
   if(phquery("fields",res,sizeof(res))) {
      nfld = 0;
      s = res;
      while((s=strstr(s,"-200:"))!=NULL) {
         s2 = strstr(s+5,":");
         s3 = strstr(s2+1,":");
         strncpy(flds[nfld],s2+1,s3-s2-1);
         flds[nfld][s3-s2-1] = '\0';
         if(strstr(s,"Lookup")<strstr(s,"\n")) nfld++;
         s = s3+1;
      }
      for(i=0;i<nfld;i++) {
         sprintf(tmp,"query %s=%s",flds[i],q);
#ifdef PW
         pc2isolatin(tmp);
#endif
         phquery(tmp,res,sizeof(res));
         if(strlen(res)>50) {
            s = res;
            oldval = 0;
            while((s=strstr(s,"-200:"))!=NULL) {
               s2 = strstr(s+5,":");
               s3 = strstr(s2+1,"\n");
               strncpy(tmp,s2+1,s3-s2);
               tmp[s3-s2] = '\0';
#ifdef PW
               isolatin2pc(tmp);
#endif
               newval = atoi(s+5);
               if((oldval>0)&&(newval!=oldval))
                  action("-------------------------\n");
               oldval = newval;
               action(tmp);
               s = s3+1;
            }
            break;
         }
      }
      return TRUE;
   } else {
      return FALSE;
   }
}
